#
# $Id: progress.tcl,v 1.1 2005/02/28 22:55:31 jenglish Exp $
#
# Tile widget set: progress bar utilities.
#

namespace eval tile::progressbar {
    variable Timers	;# Map: widget name -> after ID

    variable State
    set State(stepTime) 50
}

# Step --
#	Periodic callback procedure for autoincrement mode
#
proc tile::progressbar::Step {pb steptime stepsize} {
    variable Timers

    if {![winfo exists $pb]} {
    	# widget has been destroyed -- cancel timer
	unset -nocomplain Timers($pb)
	return
    }

    $pb step $stepsize

    set Timers($pb) [after $steptime \
    	[list tile::progressbar::Step $pb $steptime $stepsize] ]
}

# tile::progressbar::start --
#	Start autoincrement mode.
#
proc tile::progressbar::start {pb} {
    variable Timers
    variable State
    $pb configure -value 0
    if {![info exists Timers($pb)]} {
	Step $pb $State(stepTime) 1
    }
}

# tile::progressbar::stop --
#	Cancel autoincrement mode
#
proc tile::progressbar::stop {pb} {
    variable Timers
    if {[info exists Timers($pb)]} {
	after cancel $Timers($pb)
	unset Timers($pb)
    }
    $pb configure -value 0
}

